searchData={"items":[{"type":"task","title":"mix place.import","doc":"","ref":"Mix.Tasks.Place.Import.html"},{"type":"function","title":"Mix.Tasks.Place.Import.run/1","doc":"","ref":"Mix.Tasks.Place.Import.html#run/1"},{"type":"module","title":"Place","doc":"Query API and GenServer for Place, a dataset of countries, states and cities\naround the world.","ref":"Place.html"},{"type":"function","title":"Place.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Place.html#child_spec/1"},{"type":"function","title":"Place.get_cities/1","doc":"Get an unordered list of all cities by the given country code, and optional\nstate code.","ref":"Place.html#get_cities/1"},{"type":"function","title":"Options - Place.get_cities/1","doc":"* `:country_code` - An [ISO 3166-1\n    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code.\n  * `:state_code` - A state code.","ref":"Place.html#get_cities/1-options"},{"type":"function","title":"Examples - Place.get_cities/1","doc":"iex> cities = Place.get_cities(country_code: \"US\")\n    iex> Enum.find(cities, &(&1.name == \"Los Angeles\")).latitude\n    \"34.05223000\"\n\n    iex> cities = Place.get_cities(country_code: \"US\", state_code: \"CA\")\n    iex> Enum.find(cities, &(&1.name == \"Los Angeles\")).latitude\n    \"34.05223000\"","ref":"Place.html#get_cities/1-examples"},{"type":"function","title":"Place.get_cities/2","doc":"Like `get_cities/1` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#get_cities/2"},{"type":"function","title":"Examples - Place.get_cities/2","doc":"iex> db = Place.load_db!()\n    iex> cities = Place.get_cities(db, country_code: \"US\")\n    iex> Enum.find(cities, &(&1.name == \"Los Angeles\")).latitude\n    \"34.05223000\"\n\n    iex> db = Place.load_db!()\n    iex> cities = Place.get_cities(db, country_code: \"US\", state_code: \"CA\")\n    iex> Enum.find(cities, &(&1.name == \"Los Angeles\")).latitude\n    \"34.05223000\"","ref":"Place.html#get_cities/2-examples"},{"type":"function","title":"Place.get_city/1","doc":"Get a city by the given country code, state code and city name.","ref":"Place.html#get_city/1"},{"type":"function","title":"Options - Place.get_city/1","doc":"* `:country_code` - An [ISO 3166-1\n    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code.\n  * `:state_code` - A state code.\n  * `:city_name` - A city name.","ref":"Place.html#get_city/1-options"},{"type":"function","title":"Examples - Place.get_city/1","doc":"iex> Place.get_city(country_code: \"US\", state_code: \"CA\", city_name: \"Los Angeles\").latitude\n    \"34.05223000\"","ref":"Place.html#get_city/1-examples"},{"type":"function","title":"Place.get_city/2","doc":"Like `get_city/1` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#get_city/2"},{"type":"function","title":"Examples - Place.get_city/2","doc":"iex> db = Place.load_db!()\n    iex> Place.get_city(db, country_code: \"US\", state_code: \"CA\", city_name: \"Los Angeles\").latitude\n    \"34.05223000\"","ref":"Place.html#get_city/2-examples"},{"type":"function","title":"Place.get_countries/0","doc":"Get an unordered list of all countries.","ref":"Place.html#get_countries/0"},{"type":"function","title":"Examples - Place.get_countries/0","doc":"iex> countries = Place.get_countries()\n    iex> Enum.find(countries, &(&1.iso2 == \"US\")).name\n    \"United States\"","ref":"Place.html#get_countries/0-examples"},{"type":"function","title":"Place.get_countries/1","doc":"Like `get_countries/0` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#get_countries/1"},{"type":"function","title":"Examples - Place.get_countries/1","doc":"iex> db = Place.load_db!()\n    iex> countries = Place.get_countries(db)\n    iex> Enum.find(countries, &(&1.iso2 == \"US\")).name\n    \"United States\"","ref":"Place.html#get_countries/1-examples"},{"type":"function","title":"Place.get_country/1","doc":"Get a country by the given country code.","ref":"Place.html#get_country/1"},{"type":"function","title":"Options - Place.get_country/1","doc":"* `:country_code` - An [ISO 3166-1\n    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code.","ref":"Place.html#get_country/1-options"},{"type":"function","title":"Examples - Place.get_country/1","doc":"iex> Place.get_country(country_code: \"US\").name\n    \"United States\"","ref":"Place.html#get_country/1-examples"},{"type":"function","title":"Place.get_country/2","doc":"Like `get_country/1` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#get_country/2"},{"type":"function","title":"Examples - Place.get_country/2","doc":"iex> db = Place.load_db!()\n    iex> Place.get_country(db, country_code: \"US\").name\n    \"United States\"","ref":"Place.html#get_country/2-examples"},{"type":"function","title":"Place.get_state/1","doc":"Get a state by the given country code and state code.","ref":"Place.html#get_state/1"},{"type":"function","title":"Options - Place.get_state/1","doc":"* `:country_code` - An [ISO 3166-1\n    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code.\n  * `:state_code` - A state code.","ref":"Place.html#get_state/1-options"},{"type":"function","title":"Examples - Place.get_state/1","doc":"iex> Place.get_state(country_code: \"US\", state_code: \"CA\").name\n    \"California\"","ref":"Place.html#get_state/1-examples"},{"type":"function","title":"Place.get_state/2","doc":"Like `get_state/1` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#get_state/2"},{"type":"function","title":"Examples - Place.get_state/2","doc":"iex> db = Place.load_db!()\n    iex> Place.get_state(db, country_code: \"US\", state_code: \"CA\").name\n    \"California\"","ref":"Place.html#get_state/2-examples"},{"type":"function","title":"Place.get_states/1","doc":"Get an unordered list of all states by the given country code.","ref":"Place.html#get_states/1"},{"type":"function","title":"Options - Place.get_states/1","doc":"* `:country_code` - An [ISO 3166-1\n    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code.","ref":"Place.html#get_states/1-options"},{"type":"function","title":"Examples - Place.get_states/1","doc":"iex> states = Place.get_states(country_code: \"US\")\n    iex> Enum.find(states, &(&1.state_code == \"CA\")).name\n    \"California\"","ref":"Place.html#get_states/1-examples"},{"type":"function","title":"Place.get_states/2","doc":"Like `get_states/1` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#get_states/2"},{"type":"function","title":"Examples - Place.get_states/2","doc":"iex> db = Place.load_db!()\n    iex> states = Place.get_states(db, country_code: \"US\")\n    iex> Enum.find(states, &(&1.state_code == \"CA\")).name\n    \"California\"","ref":"Place.html#get_states/2-examples"},{"type":"function","title":"Place.has_states?/1","doc":"Check if the country by the given country code has any states.","ref":"Place.html#has_states?/1"},{"type":"function","title":"Options - Place.has_states?/1","doc":"* `:country_code` - An [ISO 3166-1\n    alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code.","ref":"Place.html#has_states?/1-options"},{"type":"function","title":"Examples - Place.has_states?/1","doc":"iex> Place.has_states?(country_code: \"US\")\n    {:ok, true}","ref":"Place.html#has_states?/1-examples"},{"type":"function","title":"Place.has_states?/2","doc":"Like `has_states?/1` but takes a `%Place.DB{}` as the first argument.","ref":"Place.html#has_states?/2"},{"type":"function","title":"Examples - Place.has_states?/2","doc":"iex> db = Place.load_db!()\n    iex> Place.has_states?(db, country_code: \"US\")\n    {:ok, true}","ref":"Place.html#has_states?/2-examples"},{"type":"function","title":"Place.load_db!/0","doc":"Reads and deserializes the database file into a `%Place.DB{}` struct.","ref":"Place.html#load_db!/0"},{"type":"function","title":"Examples - Place.load_db!/0","doc":"iex> db = Place.load_db!()\n    iex> Enum.count(db.countries)\n    250","ref":"Place.html#load_db!/0-examples"},{"type":"function","title":"Place.start_link/1","doc":"","ref":"Place.html#start_link/1"},{"type":"module","title":"Place.City","doc":"","ref":"Place.City.html"},{"type":"type","title":"Place.City.t/0","doc":"","ref":"Place.City.html#t:t/0"},{"type":"module","title":"Place.Country","doc":"","ref":"Place.Country.html"},{"type":"type","title":"Place.Country.t/0","doc":"","ref":"Place.Country.html#t:t/0"},{"type":"module","title":"Place.DB","doc":"","ref":"Place.DB.html"},{"type":"type","title":"Place.DB.t/0","doc":"","ref":"Place.DB.html#t:t/0"},{"type":"module","title":"Place.State","doc":"","ref":"Place.State.html"},{"type":"type","title":"Place.State.t/0","doc":"","ref":"Place.State.html#t:t/0"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2024 Andreas Geffen Lundahl\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license-1.html"},{"type":"extras","title":"LICENSE","doc":"","ref":"license-2.html"},{"type":"extras","title":"ODC Open Database License (ODbL) - LICENSE","doc":"","ref":"license-2.html#odc-open-database-license-odbl"},{"type":"extras","title":"Preamble - LICENSE","doc":"The Open Database License (ODbL) is a license agreement intended to\nallow users to freely share, modify, and use this Database while\nmaintaining this same freedom for others. Many databases are covered by\ncopyright, and therefore this document licenses these rights. Some\njurisdictions, mainly in the European Union, have specific rights that\ncover databases, and so the ODbL addresses these rights, too. Finally,\nthe ODbL is also an agreement in contract for users of this Database to\nact in certain ways in return for accessing this Database.\n\nDatabases can contain a wide variety of types of content (images,\naudiovisual material, and sounds all in the same database, for example),\nand so the ODbL only governs the rights over the Database, and not the\ncontents of the Database individually. Licensors should use the ODbL\ntogether with another license for the contents, if the contents have a\nsingle set of rights that uniformly covers all of the contents. If the\ncontents have multiple sets of different rights, Licensors should\ndescribe what rights govern what contents together in the individual\nrecord or in some other way that clarifies what rights apply. \n\nSometimes the contents of a database, or the database itself, can be\ncovered by other rights not addressed here (such as private contracts,\ntrade mark over the name, or privacy rights / data protection rights\nover information in the contents), and so you are advised that you may\nhave to consult other documents or clear other rights before doing\nactivities not covered by this License.\n\n------\n\nThe Licensor (as defined below) \n\nand \n\nYou (as defined below) \n\nagree as follows:","ref":"license-2.html#preamble"},{"type":"extras","title":"1.0 Definitions of Capitalised Words - LICENSE","doc":"\"Collective Database\" - Means this Database in unmodified form as part\nof a collection of independent databases in themselves that together are\nassembled into a collective whole. A work that constitutes a Collective\nDatabase will not be considered a Derivative Database.\n\n\"Convey\" - As a verb, means Using the Database, a Derivative Database,\nor the Database as part of a Collective Database in any way that enables\na Person to make or receive copies of the Database or a Derivative\nDatabase.  Conveying does not include interaction with a user through a\ncomputer network, or creating and Using a Produced Work, where no\ntransfer of a copy of the Database or a Derivative Database occurs.\n\"Contents\" - The contents of this Database, which includes the\ninformation, independent works, or other material collected into the\nDatabase. For example, the contents of the Database could be factual\ndata or works such as images, audiovisual material, text, or sounds.\n\n\"Database\" - A collection of material (the Contents) arranged in a\nsystematic or methodical way and individually accessible by electronic\nor other means offered under the terms of this License.\n\n\"Database Directive\" - Means Directive 96/9/EC of the European\nParliament and of the Council of 11 March 1996 on the legal protection\nof databases, as amended or succeeded.\n\n\"Database Right\" - Means rights resulting from the Chapter III (\"sui\ngeneris\") rights in the Database Directive (as amended and as transposed\nby member states), which includes the Extraction and Re-utilisation of\nthe whole or a Substantial part of the Contents, as well as any similar\nrights available in the relevant jurisdiction under Section 10.4. \n\n\"Derivative Database\" - Means a database based upon the Database, and\nincludes any translation, adaptation, arrangement, modification, or any\nother alteration of the Database or of a Substantial part of the\nContents. This includes, but is not limited to, Extracting or\nRe-utilising the whole or a Substantial part of the Contents in a new\nDatabase.\n\n\"Extraction\" - Means the permanent or temporary transfer of all or a\nSubstantial part of the Contents to another medium by any means or in\nany form.\n\n\"License\" - Means this license agreement and is both a license of rights\nsuch as copyright and Database Rights and an agreement in contract.\n\n\"Licensor\" - Means the Person that offers the Database under the terms\nof this License. \n\n\"Person\" - Means a natural or legal person or a body of persons\ncorporate or incorporate.\n\n\"Produced Work\" -  a work (such as an image, audiovisual material, text,\nor sounds) resulting from using the whole or a Substantial part of the\nContents (via a search or other query) from this Database, a Derivative\nDatabase, or this Database as part of a Collective Database.  \n\n\"Publicly\" - means to Persons other than You or under Your control by\neither more than 50% ownership or by the power to direct their\nactivities (such as contracting with an independent consultant). \n\n\"Re-utilisation\" - means any form of making available to the public all\nor a Substantial part of the Contents by the distribution of copies, by\nrenting, by online or other forms of transmission.\n\n\"Substantial\" - Means substantial in terms of quantity or quality or a\ncombination of both. The repeated and systematic Extraction or\nRe-utilisation of insubstantial parts of the Contents may amount to the\nExtraction or Re-utilisation of a Substantial part of the Contents.\n\n\"Use\" - As a verb, means doing any act that is restricted by copyright\nor Database Rights whether in the original medium or any other; and\nincludes without limitation distributing, copying, publicly performing,\npublicly displaying, and preparing derivative works of the Database, as\nwell as modifying the Database as may be technically necessary to use it\nin a different mode or format. \n\n\"You\" - Means a Person exercising rights under this License who has not\npreviously violated the terms of this License with respect to the\nDatabase, or who has received express permission from the Licensor to\nexercise rights under this License despite a previous violation.\n\nWords in the singular include the plural and vice versa.","ref":"license-2.html#1-0-definitions-of-capitalised-words"},{"type":"extras","title":"2.0 What this License covers - LICENSE","doc":"2.1. Legal effect of this document. This License is:\n\n  a. A license of applicable copyright and neighbouring rights;\n\n  b. A license of the Database Right; and\n\n  c. An agreement in contract between You and the Licensor.\n\n2.2 Legal rights covered. This License covers the legal rights in the\nDatabase, including:\n\n  a. Copyright. Any copyright or neighbouring rights in the Database.\n  The copyright licensed includes any individual elements of the\n  Database, but does not cover the copyright over the Contents\n  independent of this Database. See Section 2.4 for details. Copyright\n  law varies between jurisdictions, but is likely to cover: the Database\n  model or schema, which is the structure, arrangement, and organisation\n  of the Database, and can also include the Database tables and table\n  indexes; the data entry and output sheets; and the Field names of\n  Contents stored in the Database;\n\n  b. Database Rights. Database Rights only extend to the Extraction and\n  Re-utilisation of the whole or a Substantial part of the Contents.\n  Database Rights can apply even when there is no copyright over the\n  Database. Database Rights can also apply when the Contents are removed\n  from the Database and are selected and arranged in a way that would\n  not infringe any applicable copyright; and\n\n  c. Contract. This is an agreement between You and the Licensor for\n  access to the Database. In return you agree to certain conditions of\n  use on this access as outlined in this License. \n\n2.3 Rights not covered. \n\n  a. This License does not apply to computer programs used in the making\n  or operation of the Database; \n\n  b. This License does not cover any patents over the Contents or the\n  Database; and\n\n  c. This License does not cover any trademarks associated with the\n  Database. \n\n2.4 Relationship to Contents in the Database. The individual items of\nthe Contents contained in this Database may be covered by other rights,\nincluding copyright, patent, data protection, privacy, or personality\nrights, and this License does not cover any rights (other than Database\nRights or in contract) in individual Contents contained in the Database.\nFor example, if used on a Database of images (the Contents), this\nLicense would not apply to copyright over individual images, which could\nhave their own separate licenses, or one single license covering all of\nthe rights over the images.","ref":"license-2.html#2-0-what-this-license-covers"},{"type":"extras","title":"3.0 Rights granted - LICENSE","doc":"3.1 Subject to the terms and conditions of this License, the Licensor\ngrants to You a worldwide, royalty-free, non-exclusive, terminable (but\nonly under Section 9) license to Use the Database for the duration of\nany applicable copyright and Database Rights. These rights explicitly\ninclude commercial use, and do not exclude any field of endeavour. To\nthe extent possible in the relevant jurisdiction, these rights may be\nexercised in all media and formats whether now known or created in the\nfuture. \n\nThe rights granted cover, for example:\n\n  a. Extraction and Re-utilisation of the whole or a Substantial part of\n  the Contents;\n\n  b. Creation of Derivative Databases;\n\n  c. Creation of Collective Databases;\n\n  d. Creation of temporary or permanent reproductions by any means and\n  in any form, in whole or in part, including of any Derivative\n  Databases or as a part of Collective Databases; and\n\n  e. Distribution, communication, display, lending, making available, or\n  performance to the public by any means and in any form, in whole or in\n  part, including of any Derivative Database or as a part of Collective\n  Databases.\n\n3.2 Compulsory license schemes. For the avoidance of doubt:\n\n  a. Non-waivable compulsory license schemes. In those jurisdictions in\n  which the right to collect royalties through any statutory or\n  compulsory licensing scheme cannot be waived, the Licensor reserves\n  the exclusive right to collect such royalties for any exercise by You\n  of the rights granted under this License;\n\n  b. Waivable compulsory license schemes. In those jurisdictions in\n  which the right to collect royalties through any statutory or\n  compulsory licensing scheme can be waived, the Licensor waives the\n  exclusive right to collect such royalties for any exercise by You of\n  the rights granted under this License; and,\n\n  c. Voluntary license schemes. The Licensor waives the right to collect\n  royalties, whether individually or, in the event that the Licensor is\n  a member of a collecting society that administers voluntary licensing\n  schemes, via that society, from any exercise by You of the rights\n  granted under this License.\n\n3.3 The right to release the Database under different terms, or to stop\ndistributing or making available the Database, is reserved. Note that\nthis Database may be multiple-licensed, and so You may have the choice\nof using alternative licenses for this Database. Subject to Section\n10.4, all other rights not expressly granted by Licensor are reserved.","ref":"license-2.html#3-0-rights-granted"},{"type":"extras","title":"4.0 Conditions of Use - LICENSE","doc":"4.1 The rights granted in Section 3 above are expressly made subject to\nYour complying with the following conditions of use. These are important\nconditions of this License, and if You fail to follow them, You will be\nin material breach of its terms.\n\n4.2 Notices. If You Publicly Convey this Database, any Derivative\nDatabase, or the Database as part of a Collective Database, then You\nmust: \n\n  a. Do so only under the terms of this License or another license\n  permitted under Section 4.4;\n\n  b. Include a copy of this License (or, as applicable, a license\n  permitted under Section 4.4) or its Uniform Resource Identifier (URI)\n  with the Database or Derivative Database, including both in the\n  Database or Derivative Database and in any relevant documentation; and\n\n  c. Keep intact any copyright or Database Right notices and notices\n  that refer to this License.\n\n  d. If it is not possible to put the required notices in a particular\n  file due to its structure, then You must include the notices in a\n  location (such as a relevant directory) where users would be likely to\n  look for it.\n\n4.3 Notice for using output (Contents). Creating and Using a Produced\nWork does not require the notice in Section 4.2. However, if you\nPublicly Use a Produced Work, You must include a notice associated with\nthe Produced Work reasonably calculated to make any Person that uses,\nviews, accesses, interacts with, or is otherwise exposed to the Produced\nWork aware that Content was obtained from the Database, Derivative\nDatabase, or the Database as part of a Collective Database, and that it\nis available under this License.\n\n  a. Example notice. The following text will satisfy notice under\n  Section 4.3:\n\n        Contains information from DATABASE NAME, which is made available\n        here under the Open Database License (ODbL).\n\nDATABASE NAME should be replaced with the name of the Database and a\nhyperlink to the URI of the Database. \"Open Database License\" should\ncontain a hyperlink to the URI of the text of this License. If\nhyperlinks are not possible, You should include the plain text of the\nrequired URI's with the above notice.\n \n4.4 Share alike. \n\n  a. Any Derivative Database that You Publicly Use must be only under\n  the terms of: \n\n    i. This License;\n\n    ii. A later version of this License similar in spirit to this\n      License; or\n\n    iii. A compatible license. \n\n  If You license the Derivative Database under one of the licenses\n  mentioned in (iii), You must comply with the terms of that license. \n\n  b. For the avoidance of doubt, Extraction or Re-utilisation of the\n  whole or a Substantial part of the Contents into a new database is a\n  Derivative Database and must comply with Section 4.4. \n\n  c. Derivative Databases and Produced Works.  A Derivative Database is\n  Publicly Used and so must comply with Section 4.4. if a Produced Work\n  created from the Derivative Database is Publicly Used.\n\n  d. Share Alike and additional Contents. For the avoidance of doubt,\n  You must not add Contents to Derivative Databases under Section 4.4 a\n  that are incompatible with the rights granted under this License. \n\n  e. Compatible licenses. Licensors may authorise a proxy to determine\n  compatible licenses under Section 4.4 a iii. If they do so, the\n  authorised proxy's public statement of acceptance of a compatible\n  license grants You permission to use the compatible license.\n\n\n4.5 Limits of Share Alike.  The requirements of Section 4.4 do not apply\nin the following:\n\n  a. For the avoidance of doubt, You are not required to license\n  Collective Databases under this License if You incorporate this\n  Database or a Derivative Database in the collection, but this License\n  still applies to this Database or a Derivative Database as a part of\n  the Collective Database; \n\n  b. Using this Database, a Derivative Database, or this Database as\n  part of a Collective Database to create a Produced Work does not\n  create a Derivative Database for purposes of  Section 4.4; and\n\n  c. Use of a Derivative Database internally within an organisation is\n  not to the public and therefore does not fall under the requirements\n  of Section 4.4.\n\n4.6 Access to Derivative Databases. If You Publicly Use a Derivative\nDatabase or a Produced Work from a Derivative Database, You must also\noffer to recipients of the Derivative Database or Produced Work a copy\nin a machine readable form of:\n\n  a. The entire Derivative Database; or\n\n  b. A file containing all of the alterations made to the Database or\n  the method of making the alterations to the Database (such as an\n  algorithm), including any additional Contents, that make up all the\n  differences between the Database and the Derivative Database.\n\nThe Derivative Database (under a.) or alteration file (under b.) must be\navailable at no more than a reasonable production cost for physical\ndistributions and free of charge if distributed over the internet.\n\n4.7 Technological measures and additional terms\n\n  a. This License does not allow You to impose (except subject to\n  Section 4.7 b.)  any terms or any technological measures on the\n  Database, a Derivative Database, or the whole or a Substantial part of\n  the Contents that alter or restrict the terms of this License, or any\n  rights granted under it, or have the effect or intent of restricting\n  the ability of any person to exercise those rights.\n\n  b. Parallel distribution. You may impose terms or technological\n  measures on the Database, a Derivative Database, or the whole or a\n  Substantial part of the Contents (a \"Restricted Database\") in\n  contravention of Section 4.74 a. only if You also make a copy of the\n  Database or a Derivative Database available to the recipient of the\n  Restricted Database:\n\n    i. That is available without additional fee;\n\n    ii. That is available in a medium that does not alter or restrict\n    the terms of this License, or any rights granted under it, or have\n    the effect or intent of restricting the ability of any person to\n    exercise those rights (an \"Unrestricted Database\"); and\n\n    iii. The Unrestricted Database is at least as accessible to the\n    recipient as a practical matter as the Restricted Database.\n\n  c. For the avoidance of doubt, You may place this Database or a\n  Derivative Database in an authenticated environment, behind a\n  password, or within a similar access control scheme provided that You\n  do not alter or restrict the terms of this License or any rights\n  granted under it or have the effect or intent of restricting the\n  ability of any person to exercise those rights. \n\n4.8 Licensing of others. You may not sublicense the Database. Each time\nYou communicate the Database, the whole or Substantial part of the\nContents, or any Derivative Database to anyone else in any way, the\nLicensor offers to the recipient a license to the Database on the same\nterms and conditions as this License. You are not responsible for\nenforcing compliance by third parties with this License, but You may\nenforce any rights that You have over a Derivative Database. You are\nsolely responsible for any modifications of a Derivative Database made\nby You or another Person at Your direction. You may not impose any\nfurther restrictions on the exercise of the rights granted or affirmed\nunder this License.","ref":"license-2.html#4-0-conditions-of-use"},{"type":"extras","title":"5.0 Moral rights - LICENSE","doc":"5.1 Moral rights. This section covers moral rights, including any rights\nto be identified as the author of the Database or to object to treatment\nthat would otherwise prejudice the author's honour and reputation, or\nany other derogatory treatment:\n\n  a. For jurisdictions allowing waiver of moral rights, Licensor waives\n  all moral rights that Licensor may have in the Database to the fullest\n  extent possible by the law of the relevant jurisdiction under Section\n  10.4; \n\n  b. If waiver of moral rights under Section 5.1 a in the relevant\n  jurisdiction is not possible, Licensor agrees not to assert any moral\n  rights over the Database and waives all claims in moral rights to the\n  fullest extent possible by the law of the relevant jurisdiction under\n  Section 10.4; and\n\n  c. For jurisdictions not allowing waiver or an agreement not to assert\n  moral rights under Section 5.1 a and b, the author may retain their\n  moral rights over certain aspects of the Database.\n\nPlease note that some jurisdictions do not allow for the waiver of moral\nrights, and so moral rights may still subsist over the Database in some\njurisdictions.","ref":"license-2.html#5-0-moral-rights"},{"type":"extras","title":"6.0 Fair dealing, Database exceptions, and other rights not affected - LICENSE","doc":"6.1 This License does not affect any rights that You or anyone else may\nindependently have under any applicable law to make any use of this\nDatabase, including without limitation:\n\n  a. Exceptions to the Database Right including: Extraction of Contents\n  from non-electronic Databases for private purposes, Extraction for\n  purposes of illustration for teaching or scientific research, and\n  Extraction or Re-utilisation for public security or an administrative\n  or judicial procedure. \n\n  b. Fair dealing, fair use, or any other legally recognised limitation\n  or exception to infringement of copyright or other applicable laws. \n\n6.2 This License does not affect any rights of lawful users to Extract\nand Re-utilise insubstantial parts of the Contents, evaluated\nquantitatively or qualitatively, for any purposes whatsoever, including\ncreating a Derivative Database (subject to other rights over the\nContents, see Section 2.4). The repeated and systematic Extraction or\nRe-utilisation of insubstantial parts of the Contents may however amount\nto the Extraction or Re-utilisation of a Substantial part of the\nContents.","ref":"license-2.html#6-0-fair-dealing-database-exceptions-and-other-rights-not-affected"},{"type":"extras","title":"7.0 Warranties and Disclaimer - LICENSE","doc":"7.1 The Database is licensed by the Licensor \"as is\" and without any\nwarranty of any kind, either express, implied, or arising by statute,\ncustom, course of dealing, or trade usage. Licensor specifically\ndisclaims any and all implied warranties or conditions of title,\nnon-infringement, accuracy or completeness, the presence or absence of\nerrors, fitness for a particular purpose, merchantability, or otherwise.\nSome jurisdictions do not allow the exclusion of implied warranties, so\nthis exclusion may not apply to You.","ref":"license-2.html#7-0-warranties-and-disclaimer"},{"type":"extras","title":"8.0 Limitation of liability - LICENSE","doc":"8.1 Subject to any liability that may not be excluded or limited by law,\nthe Licensor is not liable for, and expressly excludes, all liability\nfor loss or damage however and whenever caused to anyone by any use\nunder this License, whether by You or by anyone else, and whether caused\nby any fault on the part of the Licensor or not. This exclusion of\nliability includes, but is not limited to, any special, incidental,\nconsequential, punitive, or exemplary damages such as loss of revenue,\ndata, anticipated profits, and lost business. This exclusion applies\neven if the Licensor has been advised of the possibility of such\ndamages.\n\n8.2 If liability may not be excluded by law, it is limited to actual and\ndirect financial loss to the extent it is caused by proved negligence on\nthe part of the Licensor.","ref":"license-2.html#8-0-limitation-of-liability"},{"type":"extras","title":"9.0 Termination of Your rights under this License - LICENSE","doc":"9.1 Any breach by You of the terms and conditions of this License\nautomatically terminates this License with immediate effect and without\nnotice to You. For the avoidance of doubt, Persons who have received the\nDatabase, the whole or a Substantial part of the Contents, Derivative\nDatabases, or the Database as part of a Collective Database from You\nunder this License will not have their licenses terminated provided\ntheir use is in full compliance with this License or a license granted\nunder Section 4.8 of this License.  Sections 1, 2, 7, 8, 9 and 10 will\nsurvive any termination of this License.\n\n9.2 If You are not in breach of the terms of this License, the Licensor\nwill not terminate Your rights under it. \n\n9.3 Unless terminated under Section 9.1, this License is granted to You\nfor the duration of applicable rights in the Database. \n\n9.4 Reinstatement of rights. If you cease any breach of the terms and\nconditions of this License, then your full rights under this License\nwill be reinstated:\n\n  a. Provisionally and subject to permanent termination until the 60th\n  day after cessation of breach; \n\n  b. Permanently on the 60th day after cessation of breach unless\n  otherwise reasonably notified by the Licensor; or\n\n  c.  Permanently if reasonably notified by the Licensor of the\n  violation, this is the first time You have received notice of\n  violation of this License from  the Licensor, and You cure the\n  violation prior to 30 days after your receipt of the notice.\n\nPersons subject to permanent termination of rights are not eligible to\nbe a recipient and receive a license under Section 4.8.\n\n9.5 Notwithstanding the above, Licensor reserves the right to release\nthe Database under different license terms or to stop distributing or\nmaking available the Database. Releasing the Database under different\nlicense terms or stopping the distribution of the Database will not\nwithdraw this License (or any other license that has been, or is\nrequired to be, granted under the terms of this License), and this\nLicense will continue in full force and effect unless terminated as\nstated above.","ref":"license-2.html#9-0-termination-of-your-rights-under-this-license"},{"type":"extras","title":"10.0 General - LICENSE","doc":"10.1 If any provision of this License is held to be invalid or\nunenforceable, that must not affect the validity or enforceability of\nthe remainder of the terms and conditions of this License and each\nremaining provision of this License shall be valid and enforced to the\nfullest extent permitted by law. \n\n10.2 This License is the entire agreement between the parties with\nrespect to the rights granted here over the Database. It replaces any\nearlier understandings, agreements or representations with respect to\nthe Database. \n\n10.3 If You are in breach of the terms of this License, You will not be\nentitled to rely on the terms of this License or to complain of any\nbreach by the Licensor. \n\n10.4 Choice of law. This License takes effect in and will be governed by\nthe laws of the relevant jurisdiction in which the License terms are\nsought to be enforced. If the standard suite of rights granted under\napplicable copyright law and Database Rights in the relevant\njurisdiction includes additional rights not granted under this License,\nthese additional rights are granted in this License in order to meet the\nterms of this License.","ref":"license-2.html#10-0-general"},{"type":"extras","title":"Place","doc":"# Place\n\nPlace is an Elixir library and dataset containing names, ISO 3166 codes,\ncurrencies and much more about countries, states and cities around the\nworld. It's using the\n[countries-states-cities-database](https://github.com/dr5hn/countries-states-cities-database)\nproject as the data source, and it's regularly updated with new data.\n\n```elixir\niex> Place.get_country(country_code: \"US\")\n%Place.Country{\n  capital: \"Washington\",\n  csc_id: 233,\n  csc_region_id: \"2\",\n  csc_subregion_id: \"6\",\n  currency: \"USD\",\n  currency_name: \"United States dollar\",\n  currency_symbol: \"$\",\n  emoji: \"🇺🇸\",\n  emojiU: \"U+1F1FA U+1F1F8\",\n  iso2: \"US\",\n  iso3: \"USA\",\n  latitude: \"38.00000000\",\n  longitude: \"-97.00000000\",\n  name: \"United States\",\n  nationality: \"American\",\n  native: \"United States\",\n  numeric_code: \"840\",\n  phone_code: \"1\",\n  ... # and more\n}\n```","ref":"readme.html"},{"type":"extras","title":"Installation - Place","doc":"Add `:place` to your `mix.exs`:\n\n```elixir\n{:place, \"~> 0.1\"}\n```\n\nAdd `Place` to your application's supervisor (read more under usage for an\n[alternative approach](#loading-the-database-explicitly)):\n\n```elixir\n# lib/my_app/application.ex\ndef start(_type, _args) do\n  children = [\n    ...,\n    Place\n  ]\n\n  Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Place","doc":"Place provides functions for getting countries, states and cities. The\n[documentation for the `Place` module](https://hexdocs.pm/place/Place.html)\ncontains detailed information about each function, but here are a few examples:\n\nGet a list of all countries:\n\n```elixir\niex> Place.get_countries() |> Enum.count()\n250\n```\n\nGet all states in a country:\n\n```elixir\niex> Place.get_states(country_code: \"US\") |> Enum.count()\n66 # The extra 16 are non-state US territories, which can be identified by the `type` field.\n```\n\nGet all cities in a state:\n\n```elixir\niex> Place.get_cities(country_code: \"US\", state_code: \"CA\") |> Enum.count()\n1124\n```\n\nGet a country:\n\n```elixir\niex> Place.get_country(country_code: \"US\")\n%Place.Country{\n  ...,\n  name: \"United States\",\n  ...\n}\n```\n\nGet a state:\n\n```elixir\niex> Place.get_state(country_code: \"US\", state_code: \"CA\")\n%Place.State{\n  ...,\n  name: \"California\",\n  ...\n}\n```\n\nGet a city:\n\n```elixir\niex> Place.get_city(country_code: \"US\", state_code: \"CA\", city_name: \"Los Angeles\")\n%Place.City{\n  ...,\n  name: \"Los Angeles\",\n  ...\n}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Loading the database explicitly - Place","doc":"Place ships with a compressed database file, containing the\n[countries-states-cities-database](https://github.com/dr5hn/countries-states-cities-database)\ndataset. The `Place` module is a GenServer that at startup reads the file and\nholds it as state in a `%Place.DB{}` struct. This is convenient, since you don't\nhave to think about passing around the struct, and for most use cases the\noverhead of the interprocess communication is negligible.\n\nHowever, if you don't want to add `Place` to your application's supervisor or if\nwant to directly access the `%Place.DB{}` struct, you can use\n`Place.load_db!()`. Most of the functions in Place's API ships with two arities,\none that assumes the GenServer is running and one that explicitly takes a\n`%Place.DB{}`. For example:\n\n```elixir\niex> Place.get_countries() # First option\niex> Place.load_db!() |> Place.get_countries() # Second option\n```","ref":"readme.html#loading-the-database-explicitly"},{"type":"extras","title":"License - Place","doc":"Place is released under the MIT license and the database file is released under\nthe ODbL-1.0 license. See the [LICENSE](LICENSE) and\n[priv/countries-states-cities-database/LICENSE](priv/countries-states-cities-database/LICENSE)\nfiles respectively for more information.","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}